# Form implementation generated from reading ui file 'gui.ui'
#
# Created by: PyQt6 UI code generator 6.1.1
#
# WARNING: Any manual changes made to this file will be lost when pyuic6 is
# run again.  Do not edit this file unless you know what you are doing.

import sys
from PySide6 import QtCore, QtGui, QtWidgets
from enum import IntFlag, auto, Enum
from os import path
from . editor import ManifestEditor
from . blapi import BLAPI
from . pennapi import PENNAPI

class Prereqs(IntFlag):
    COLLEX = auto()
    DATASET = auto()
    CSV = auto()
    AUTOFMT = auto()
    MANFMT = auto()
    CHKCMP = auto()
    CMP = auto()

class States(Enum):
    GETTOPINFO = auto()
    GETFMT = auto()
    READY = auto()

class Ui_dlgMain(object):

    def __init__(self):
        self.ME = ManifestEditor()
        self.PENNAPI = PENNAPI(
            api_username="maci@mbfbioscience.com",
            api_password="Sunfl0wer22!",
            aws_key="e0afc7ce-f95d-447b-b640-4463533d0081",
            aws_secret="bdee1d0a-1088-45db-846e-a36f4156fb63"
            )
        _ = self.PENNAPI.auth()
        self.BLAPI = BLAPI()
        if not self.BLAPI.authenticate("sparcadmin", "cqdpG1fAEO5QJC2KQDM7"):
            sys.exit("Could not authenticate")
        self.state = States.GETTOPINFO
        self.prereqs = Prereqs(0)
        self.waitIcon = None
        self.readyIcon = None
        self.finishedIcon = None
        self.imgformat = str()
        self.dsid = str()
        self.cmpratio = 0
        self.error = str()
        self.defaultlabel = "Could not determine original image file format from manifest data."
        self.thisdir = path.dirname(path.abspath(__file__)) + "\\"
        self.recentlyFinished = False
        self.cbxfmts = {
            "JPEG2000" : ".jp2",
            "JPEG" : ".jpg",
            "Standard TIFF" : ".tiff",
            "Vesalius TIFF" : ".tiff",
            "Olympus FluoView TIFF" : ".tiff",
            "OME-TIFF" : ".tiff",
            "Keyence TIFF" : ".tiff",
            "Imaris TIFF" : ".tiff",
            "Zeiss CZI" : ".czi",
            "Leica LIF" : ".lif",
            "Zeiss LSM" : ".lsm",
            "Aperio SVS" : ".svs",
            "CaliberID " : ".tiff",
            "Olympus OIB" : ".oib",
            "Olympus OIF" : ".oif",
            "Imaris IMS" : ".ims",
            "Nikon ND2" : ".nd2",
            "Hamamatsu NDPI" : ".ndpi"
        }
        self.dsidmap = dict()

    def __del__(self):
        self.BLAPI.disconnect()
        
    def setupUi(self, dlgMain):
        dlgMain.setObjectName("dlgMain")
        dlgMain.resize(500, 350)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.MinimumExpanding, QtWidgets.QSizePolicy.Policy.MinimumExpanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(dlgMain.sizePolicy().hasHeightForWidth())
        dlgMain.setSizePolicy(sizePolicy)
        dlgMain.setMinimumSize(QtCore.QSize(500, 350))
        dlgMain.setMaximumSize(QtCore.QSize(1000, 550))
        self.verticalLayout = QtWidgets.QVBoxLayout(dlgMain)
        self.verticalLayout.setObjectName("verticalLayout")
        self.glTop = QtWidgets.QGridLayout()
        self.glTop.setObjectName("glTop")
        self.lblCollection = QtWidgets.QLabel(dlgMain)
        self.lblCollection.setMinimumSize(QtCore.QSize(0, 30))
        self.lblCollection.setObjectName("lblCollection")
        self.glTop.addWidget(self.lblCollection, 1, 0, 1, 1)
        self.lblManifest = QtWidgets.QLabel(dlgMain)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Preferred, QtWidgets.QSizePolicy.Policy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.lblManifest.sizePolicy().hasHeightForWidth())
        self.lblManifest.setSizePolicy(sizePolicy)
        self.lblManifest.setMinimumSize(QtCore.QSize(0, 30))
        self.lblManifest.setContextMenuPolicy(QtCore.Qt.ContextMenuPolicy.NoContextMenu)
        self.lblManifest.setTextInteractionFlags(QtCore.Qt.TextInteractionFlag.NoTextInteraction)
        self.lblManifest.setObjectName("lblManifest")
        self.glTop.addWidget(self.lblManifest, 3, 0, 1, 1)
        self.lblDataset = QtWidgets.QLabel(dlgMain)
        self.lblDataset.setMinimumSize(QtCore.QSize(0, 30))
        self.lblDataset.setObjectName("lblDataset")
        self.glTop.addWidget(self.lblDataset, 2, 0, 1, 1)
        self.ledManifest = QtWidgets.QLineEdit(dlgMain)
        self.ledManifest.setObjectName("ledManifest")
        self.glTop.addWidget(self.ledManifest, 3, 1, 1, 1)
        self.btnManifest = QtWidgets.QToolButton(dlgMain)
        icon = QtGui.QIcon()
        icon.addPixmap(QtGui.QPixmap(self.thisdir + "FolderOpen-64.png"), QtGui.QIcon.Mode.Normal, QtGui.QIcon.State.On)
        self.btnManifest.setIcon(icon)
        self.btnManifest.setObjectName("btnManifest")
        self.glTop.addWidget(self.btnManifest, 3, 2, 1, 1)
        self.cbxCollection = QtWidgets.QComboBox(dlgMain)
        self.cbxCollection.setObjectName("cbxCollection")
        self.cbxCollection.addItem("Choose...")
        collections = self.BLAPI.get_collections()
        cnames = list(collections.keys())
        cnames.sort()
        for name in cnames:
            self.cbxCollection.addItem(name)
        self.glTop.addWidget(self.cbxCollection, 1, 1, 1, 2)
        self.cbxDataset = QtWidgets.QComboBox(dlgMain)
        self.cbxDataset.setObjectName("cbxDataset")
        self.cbxDataset.addItem("Choose...")
        datasets = self.PENNAPI.swagger_get_datasets()
        for data in datasets:
            self.dsidmap[data["content"]["name"]] = data["content"]["id"]
        dsnames = list(self.dsidmap.keys())
        dsnames.sort()
        for name in dsnames:
            self.cbxDataset.addItem(name)
        self.glTop.addWidget(self.cbxDataset, 2, 1, 1, 2)
        self.verticalLayout.addLayout(self.glTop)
        self.vlCompression = QtWidgets.QVBoxLayout()
        self.vlCompression.setSizeConstraint(QtWidgets.QLayout.SizeConstraint.SetFixedSize)
        self.vlCompression.setSpacing(0)
        self.vlCompression.setObjectName("vlCompression")
        self.chkCompression = QtWidgets.QCheckBox(dlgMain)
        self.chkCompression.setMinimumSize(QtCore.QSize(0, 30))
        self.chkCompression.setLayoutDirection(QtCore.Qt.LayoutDirection.LeftToRight)
        self.chkCompression.setObjectName("chkCompression")
        self.vlCompression.addWidget(self.chkCompression)
        self.hlCompression = QtWidgets.QHBoxLayout()
        self.hlCompression.setSpacing(0)
        self.hlCompression.setObjectName("hlCompression")
        self.lblCompression = QtWidgets.QLabel(dlgMain)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Fixed, QtWidgets.QSizePolicy.Policy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.lblCompression.sizePolicy().hasHeightForWidth())
        self.lblCompression.setSizePolicy(sizePolicy)
        self.lblCompression.setMinimumSize(QtCore.QSize(150, 30))
        self.lblCompression.setMaximumSize(QtCore.QSize(100, 16777215))
        self.lblCompression.setObjectName("lblCompression")
        self.hlCompression.addWidget(self.lblCompression)
        self.ledCompression = QtWidgets.QLineEdit(dlgMain)
        self.ledCompression.setMaximumSize(QtCore.QSize(50, 16777215))
        self.ledCompression.setAlignment(QtCore.Qt.AlignmentFlag.AlignRight|QtCore.Qt.AlignmentFlag.AlignTrailing|QtCore.Qt.AlignmentFlag.AlignVCenter)
        self.ledCompression.setObjectName("ledCompression")
        self.hlCompression.addWidget(self.ledCompression)
        self.lblRatio = QtWidgets.QLabel(dlgMain)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Preferred, QtWidgets.QSizePolicy.Policy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.lblRatio.sizePolicy().hasHeightForWidth())
        self.lblRatio.setSizePolicy(sizePolicy)
        self.lblRatio.setMinimumSize(QtCore.QSize(0, 30))
        self.lblRatio.setAlignment(QtCore.Qt.AlignmentFlag.AlignLeading|QtCore.Qt.AlignmentFlag.AlignLeft|QtCore.Qt.AlignmentFlag.AlignVCenter)
        self.lblRatio.setObjectName("lblRatio")
        self.hlCompression.addWidget(self.lblRatio)
        self.vlCompression.addLayout(self.hlCompression)
        self.verticalLayout.addLayout(self.vlCompression)
        self.lblNote = QtWidgets.QLabel(dlgMain)
        self.lblNote.setEnabled(True)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Preferred, QtWidgets.QSizePolicy.Policy.MinimumExpanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.lblNote.sizePolicy().hasHeightForWidth())
        self.lblNote.setSizePolicy(sizePolicy)
        self.lblNote.setMinimumSize(QtCore.QSize(0, 30))
        font = QtGui.QFont()
        font.setBold(True)
        font.setItalic(True)
        font.setWeight(QtGui.QFont.Normal)
        self.lblNote.setFont(font)
        self.lblNote.setContextMenuPolicy(QtCore.Qt.ContextMenuPolicy.NoContextMenu)
        self.lblNote.setAlignment(QtCore.Qt.AlignmentFlag.AlignCenter)
        self.lblNote.setObjectName("lblNote")
        self.verticalLayout.addWidget(self.lblNote)
        self.hlFormat = QtWidgets.QHBoxLayout()
        self.hlFormat.setObjectName("hlFormat")
        self.lblFormat = QtWidgets.QLabel(dlgMain)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Preferred, QtWidgets.QSizePolicy.Policy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.lblFormat.sizePolicy().hasHeightForWidth())
        self.lblFormat.setSizePolicy(sizePolicy)
        self.lblFormat.setMinimumSize(QtCore.QSize(0, 30))
        self.lblFormat.setContextMenuPolicy(QtCore.Qt.ContextMenuPolicy.NoContextMenu)
        self.lblFormat.setObjectName("lblFormat")
        self.hlFormat.addWidget(self.lblFormat)
        self.cbxFormat = QtWidgets.QComboBox(dlgMain)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Policy.Fixed, QtWidgets.QSizePolicy.Policy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.cbxFormat.sizePolicy().hasHeightForWidth())
        self.cbxFormat.setSizePolicy(sizePolicy)
        self.cbxFormat.setObjectName("cbxFormat")
        self.cbxFormat.setFocusPolicy(QtCore.Qt.FocusPolicy.NoFocus)
        self.cbxFormat.addItem("Choose...")
        fmts = list(self.cbxfmts.keys())
        fmts.sort()
        for ext in fmts:
            self.cbxFormat.addItem(ext)
        self.hlFormat.addWidget(self.cbxFormat)
        self.btnProcess = QtWidgets.QPushButton(dlgMain)
        self.btnProcess.setEnabled(False)
        self.waitIcon = QtGui.QIcon()
        self.waitIcon.addFile(self.thisdir + "question-64.png", QtCore.QSize(), QtGui.QIcon.Mode.Disabled, QtGui.QIcon.State.Off)
        self.readyIcon = QtGui.QIcon(QtGui.QPixmap(self.thisdir + "Right-64.png"))
        self.btnProcess.setObjectName("btnProcess")
        self.hlFormat.addWidget(self.btnProcess)
        self.hlFormat.setStretch(0, 1)
        self.verticalLayout.addLayout(self.hlFormat)
        self.verticalLayout.setStretch(0, 0)
        self.verticalLayout.setStretch(1, 0)
        self.verticalLayout.setStretch(2, 1)
        self.verticalLayout.setStretch(3, 0)
        self.lblManifest.setBuddy(self.ledManifest)
        self.lblFormat.setBuddy(self.cbxFormat)

        self.finishedIcon = QtGui.QIcon()
        self.finishedIcon.addFile(self.thisdir + "modulecheck_64.png", QtCore.QSize())

        self.retranslateUi(dlgMain)
        QtCore.QMetaObject.connectSlotsByName(dlgMain)
        dlgMain.setTabOrder(self.ledManifest, self.btnManifest)
        dlgMain.setTabOrder(self.btnManifest, self.btnProcess)
        self.makeConnections()
        self.updateUI()

    def retranslateUi(self, dlgMain):
        _translate = QtCore.QCoreApplication.translate
        dlgMain.setWindowTitle(_translate("dlgMain", "SPARC SODA Manifest Curator"))
        self.lblCollection.setText(_translate("dlgMain", "Biolucida Collection:"))
        self.lblDataset.setText(_translate("dlgMain", "Pennsieve Dataset:"))
        self.lblManifest.setText(_translate("dlgMain", "Manifest CSV path:"))
        self.btnManifest.setText(_translate("dlgMain", "..."))
        self.chkCompression.setText(_translate("dlgMain", "JPEG2000 images are compressed"))
        self.lblCompression.setText(_translate("dlgMain", "Enter compression ratio:"))
        self.lblRatio.setText(_translate("dlgMain", ":1"))
        self.lblNote.setText(_translate("dlgMain", "Could not determine original image file format from manifest data."))
        self.lblFormat.setText(_translate("dlgMain", "Please provide image file format:"))
        self.btnProcess.setText(_translate("dlgMain", "Process"))

    def updateUI(self):
        #print("gui.py: updating UI")
        #process button should only be enabled when all required info is present
        if self.recentlyFinished:
            self.btnProcess.setIcon(self.finishedIcon)
            self.btnProcess.setEnabled(True)
        elif self.state == States.READY:
            self.btnProcess.setIcon(self.readyIcon)
            self.btnProcess.setEnabled(True)
        else:
            self.btnProcess.setIcon(self.waitIcon)
            self.btnProcess.setEnabled(False)
        #note, label, lineedit should only be visible when scan fails to find format
        hascsv = bool(self.prereqs & Prereqs.CSV)
        hasautofmt = bool(self.prereqs & Prereqs.AUTOFMT)
        fmtDispNeeded = hascsv and not hasautofmt
        self.lblFormat.setVisible(fmtDispNeeded)
        self.cbxFormat.setVisible(fmtDispNeeded)
        self.lblNote.setVisible(fmtDispNeeded)
        if len(self.error) > 0:
            self.lblNote.setText(self.error)
        else:
            self.lblNote.setText(self.defaultlabel)
        #only allow compression line edit if checkbox is checked
        self.ledCompression.setEnabled(Prereqs.CHKCMP in self.prereqs)

    def makeConnections(self):
        self.ledManifest.textEdited.connect(self.on_ledManifest_edited)
        self.ledCompression.textEdited.connect(self.on_ledCompression_edited)
        self.cbxFormat.currentIndexChanged.connect(self.on_cbxFormat_changed)
        self.cbxCollection.currentIndexChanged.connect(self.on_cbxCollection_changed)
        self.cbxDataset.currentIndexChanged.connect(self.on_cbxDataset_changed)
        self.btnManifest.released.connect(self.on_btnManifest_released)
        self.btnProcess.released.connect(self.on_btnProcess_released)
        self.chkCompression.stateChanged.connect(self.on_chkCompression_changed)

    #logic for setting current state of widget given prereqs
    def set_prereq_and_state(self, add = 0, rem = 0):
        #print("gui.py: prereq and state change")
        self.prereqs = Prereqs((self.prereqs | add) - (self.prereqs & rem))
        hasCollexCSV = Prereqs.COLLEX | Prereqs.CSV in self.prereqs
        hasFmt = bool(self.prereqs & (Prereqs.MANFMT | Prereqs.AUTOFMT))
        hasDataset = Prereqs.DATASET in self.prereqs
        cmpReady = ((Prereqs.CHKCMP | Prereqs.CMP) in self.prereqs) or not (Prereqs.CHKCMP in self.prereqs)
        if hasCollexCSV and hasDataset and cmpReady:
            if hasFmt:
                self.state = States.READY
            else:
                self.state = States.GETFMT
        else:
            self.state = States.GETTOPINFO
        if self.recentlyFinished:
            self.recentlyFinished = False
            self.updateUI()

    def set_ledManifest_state(self, csvpath):
        self.ledManifest.setText(csvpath)
        if path.isfile(csvpath):
            error = self.ME.check_manifest(csvpath)
            if error is None:
                #automatic format works
                #print("gui.py: autoformat works")
                self.set_prereq_and_state(Prereqs.CSV | Prereqs.AUTOFMT, Prereqs.MANFMT)
            elif error == 1:
                #manual format needed
                #print("gui.py: need manual format")
                self.set_prereq_and_state(Prereqs.CSV, Prereqs.AUTOFMT)
            else:
                #invalid CSV
                #print("gui.py: invalid CSV file")
                self.set_prereq_and_state(0, Prereqs.CSV | Prereqs.AUTOFMT | Prereqs.MANFMT)
                self.error = "Invalid file"
        else:
            #file doesn't exist
            #print("gui.py: CSV file doesn't exist")
            self.set_prereq_and_state(0, Prereqs.CSV | Prereqs.AUTOFMT | Prereqs.MANFMT)
        self.updateUI()
    
    def on_ledManifest_edited(self):
        csvpath = self.ledManifest.text()
        self.set_ledManifest_state(csvpath)

    def on_ledCompression_edited(self):
        cmpratio = self.ledCompression.text()
        if len(cmpratio) == 0:
            self.set_prereq_and_state(0, Prereqs.CMP)
        elif cmpratio.isnumeric():
            self.cmpratio = int(cmpratio)
            self.set_prereq_and_state(Prereqs.CMP)
        else:
            self.set_prereq_and_state(0, Prereqs.CMP)
        self.updateUI()

    def on_cbxCollection_changed(self):
        found = False
        curind = self.cbxCollection.currentIndex()
        if curind > 0:
            cbxtext = self.cbxCollection.currentText()
            for retry in range(3):
                #print("gui.py: collection tries: " + str(retry+1))
                #chose a collection
                if self.BLAPI.choose_collection(cbxtext):
                    self.set_prereq_and_state(Prereqs.COLLEX)
                    found = True
                    #print("gui.py: collection found")
                    break
        if not found:
            #chose default option
            #print("gui.py: collection not found")
            self.cbxCollection.setCurrentIndex(0)
            self.set_prereq_and_state(0, Prereqs.COLLEX)
        self.updateUI()

    def on_cbxDataset_changed(self):
        curind = self.cbxDataset.currentIndex()
        if curind > 0:
            #chose a dataset
            #print("gui.py: dataset chosen")
            dsname = self.cbxDataset.currentText()
            dsid = self.dsidmap[dsname]
            self.dsid = dsid
            self.PENNAPI.set_dsid(dsid)
            self.set_prereq_and_state(Prereqs.DATASET)
        else:
            #print("gui.py: couldn't find dataset")
            self.dsid = str()
            self.cbxDataset.setCurrentIndex(0)
            self.set_prereq_and_state(0, Prereqs.DATASET)
        self.updateUI()

    def on_cbxFormat_changed(self):
        if self.cbxFormat.currentIndex() > 0:
            #chose a format
            self.imgformat = self.cbxfmts[self.cbxFormat.currentText()]
            self.set_prereq_and_state(Prereqs.MANFMT)
        else:
            #chose default option
            self.imgformat = str()
            self.set_prereq_and_state(0, Prereqs.MANFMT)
        self.updateUI()

    def on_btnManifest_released(self):
        csvpath, _ = QtWidgets.QFileDialog.getOpenFileName(caption="Open Manifest", filter="CSV (*.csv)")
        if len(csvpath) > 0:
            self.set_ledManifest_state(csvpath)

    def on_btnProcess_released(self):
        #print("gui.py: manifest processing started...")
        blids = list()
        pckids = list()
        pckmap = self.PENNAPI.get_pckids_for_files_in_set()
        #for key in pckmap:
            #print(str(key))
        filenames = self.ME.get_filenames()
        for name in filenames:
            slashind = name.rfind("/")
            imgname = name
            if slashind > -1:
                imgname = name[slashind+1:]
            #print("  " + imgname + ":")
            imgid = int(self.BLAPI.get_img_id(imgname))
            if imgid > 0:
                #print("    BL ID: " + str(imgid))
                blids.append(str(imgid))
            else:
                #print("    BL ID absent")
                blids.append("")
            imgfound = False
            #print("    " + str(imgname in pckmap.keys()))
            if imgname in pckmap.keys():
                pckids.append(pckmap[imgname])
                imgfound = True
                #print("    Pennsieve ID: " + str(pckids[-1]))
            if not imgfound:
                repname = imgname
                extind = len(repname)
                while extind > -1:
                    #print("    trying: " + repname + self.imgformat)
                    if (repname + self.imgformat) in pckmap.keys():
                        #print("    Pennsieve ID: " + str(pckids[-1]))
                        pckids.append(pckmap[repname + self.imgformat])
                        imgfound = True
                        break
                    extind = repname.rfind(".")
                    repname = repname[:extind]
                if not imgfound:
                    #print("    Pennsieve ID absent")
                    pckids.append("")
        self.ME.set_blids(blids)
        self.ME.set_pckids(pckids)
        error = self.ME.process_manifest(self.imgformat, self.dsid, self.cmpratio)
        if error:
            self.error = error
        self.recentlyFinished = True
        self.updateUI()

    def on_chkCompression_changed(self):
        if self.chkCompression.isChecked():
            self.set_prereq_and_state(Prereqs.CHKCMP)
            self.on_ledCompression_edited()
        else:
            self.set_prereq_and_state(0, Prereqs.CHKCMP | Prereqs.CMP)
            self.cmpratio = 0
        self.updateUI()
